Search posts
Search posts with X search operators, newest or most engaged first. Paginate with cursor and has_more. A malformed query returns 400; no matches return an empty posts array.
5 credits / requestBilled only on success
Authorization
ApiKeyAuth x-api-key<token>
In: header
Query Parameters
query*string
Search text with X search operators, such as from:NASA, "exact phrase", since:2026-10-01, or #hashtag.
Length
1 <= length <= 1000sort?string
latest returns newest posts first; top returns the most engaged posts.
Default
"latest"Value in
- "latest"
- "top"
cursor?string
cursor from the previous response. Omit for the first page and send it unchanged for later pages.
Length
length <= 2000curl -X GET "https://example.com/v1/x/search?query=from%3ANASA+moon" \ -H "x-api-key: YOUR_API_KEY"{ "data": { "posts": [ { "id": "2110832251126644974", "url": "https://x.com/NASA/status/2110832251126644974", "text": "@StCroixSkol 🙌", "lang": "qme", "source": "Twitter for iPhone", "created_at": "2026-10-15T20:36:40.000Z", "like_count": 10, "reply_count": 0, "repost_count": 0, "quote_count": 0, "view_count": 2161, "bookmark_count": 0, "is_reply": true, "in_reply_to_post_id": "2110812438602076427", "in_reply_to_user_id": "2094305529736679424", "in_reply_to_handle": "StCroixSkol", "conversation_id": "2110798512795377741", "is_pinned": null, "author": { "id": "11348282", "handle": "NASA", "name": "NASA", "description": null, "location": "Pale Blue Dot", "website": null, "avatar_url": "https://pbs.twimg.com/profile_images/1321163587679784960/0ZxKlEKB_normal.jpg", "banner_url": "https://pbs.twimg.com/profile_banners/11348282/1788992290", "followers_count": 92324081, "following_count": 115, "posts_count": 74434, "media_count": 28199, "likes_count": 17030, "is_verified": false, "is_blue_verified": true, "verified_type": "Government", "protected": null, "created_at": "2007-12-19T20:20:32.000Z", "pinned_post_ids": [], "is_automated": false }, "media": [], "hashtags": [], "mentions": [ { "id": "2094305529736679424", "handle": "StCroixSkol", "name": "Kyle" } ], "urls": [], "card": null, "article": null, "place": null, "quoted_post": null, "reposted_post": null }, { "id": "2110823965954637903", "url": "https://x.com/NASA/status/2110823965954637903", "text": "LIVE: Tune in as agency leaders and partners discuss NASA's contributions to @JAXA_en's Martian Moons eXploration (MMX) mission, scheduled to lift off on Monday, Oct. 19. https://t.co/TgO3c1FmNs https://t.co/RK9OwELDC2", "lang": "en", "source": "Twitter for iPhone", "created_at": "2026-10-15T20:03:45.000Z", "like_count": 798, "reply_count": 60, "repost_count": 117, "quote_count": 9, "view_count": 302209, "bookmark_count": 39, "is_reply": false, "in_reply_to_post_id": null, "in_reply_to_user_id": null, "in_reply_to_handle": null, "conversation_id": "2110823965954637903", "is_pinned": null, "author": { "id": "11348282", "handle": "NASA", "name": "NASA", "description": null, "location": "Pale Blue Dot", "website": null, "avatar_url": "https://pbs.twimg.com/profile_images/1321163587679784960/0ZxKlEKB_normal.jpg", "banner_url": "https://pbs.twimg.com/profile_banners/11348282/1788992290", "followers_count": 92324081, "following_count": 115, "posts_count": 74434, "media_count": 28199, "likes_count": 17030, "is_verified": false, "is_blue_verified": true, "verified_type": "Government", "protected": null, "created_at": "2007-12-19T20:20:32.000Z", "pinned_post_ids": [], "is_automated": false }, "media": [ { "id": "2110821837366046721", "type": "photo", "url": "https://pbs.twimg.com/media/HUslRwhXMAEmXG2.jpg", "alt_text": "The blue NASA \"meatball\" insignia overlaid on top of a Martian background.", "width": 1920, "height": 1080, "duration_ms": null, "variants": null } ], "hashtags": [], "mentions": [ { "id": "104989762", "handle": "JAXA_en", "name": "JAXA(Japan Aerospace Exploration Agency)" } ], "urls": [ { "url": "https://t.co/TgO3c1FmNs", "expanded_url": "https://youtu.be/3k2mpWrOD1s" } ], "card": null, "article": null, "place": null, "quoted_post": null, "reposted_post": null } ], "count": 2, "cursor": "DAADDAABCgABHUsuv6zXgO4KAAIdQi7j3ReBNwAIAAIAAAACCAADAAAAAAgABAAAAAAKAAUdS-T2sEAnEAoABh1L5PawP9jwCwAH", "has_more": true }}